var LOGFILE_NAME = "thanos.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};

lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);


var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


Property.setSavedProperty=function (path,value) {
	  Property.setProperty(path, value);
	  Property.setFlag(path, 'ARCHIVE', true);
}

function fetchGeneralSettings(baseDSID) {
	lInfo.logln('fetching general Settings for ' + baseDSID);
	var baseParameter=[{
		deviceIndex:0,
		bank:127,
		index:50
	},{
		deviceIndex:0,
		bank:127,
		index:51
	},{
		deviceIndex:0,
		bank:127,
		index:52
	},{
		deviceIndex:0,
		bank:127,
		index:55
	},{
		deviceIndex:0,
		bank:127,
		index:56
	},{
		deviceIndex:0,
		bank:127,
		index:57
	},{
		deviceIndex:0,
		bank:127,
		index:58
	},{
		deviceIndex:0,
		bank:127,
		index:59
	},{
		deviceIndex:0,
		bank:127,
		index:60
	},{
		deviceIndex:0,
		bank:127,
		index:64
	},{
		deviceIndex:0,
		bank:127,
		index:68
	},{
		deviceIndex:0,
		bank:127,
		index:72
	},{
		deviceIndex:0,
		bank:127,
		index:76
	},{
		deviceIndex:0,
		bank:127,
		index:80
	},{
		deviceIndex:0,
		bank:127,
		index:84
	},{
		deviceIndex:0,
		bank:127,
		index:88
	},{
		deviceIndex:0,
		bank:127,
		index:92
	},{
		deviceIndex:0,
		bank:127,
		index:96
	},{
		deviceIndex:0,
		bank:127,
		index:100
	},{
		deviceIndex:7,
		bank:127,
		index:137
	}];

	var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
	var parentDSID=baseDSID.substring(0,baseDSID.length-3);

	var oObject=[];
	
	for (var iIndex=0;iIndex<baseParameter.length;iIndex++) {
		var actDeviceIndex=baseParameter[iIndex].deviceIndex;
		var actBank=baseParameter[iIndex].bank;
		var actIndex=baseParameter[iIndex].index;
		
		var dSID=parentDSID + '' + (baseIndex+actDeviceIndex).toString(16) + "00";			

		oObject.push({
			type:'read',
			dsid:dSID,
			bank:actBank,
			index:actIndex,
			cachePath:'devices/'+baseDSID+'/generalSettings/' + iIndex +'/value'
		});
		
		Property.setSavedProperty('devices/'+baseDSID+'/generalSettings/' + iIndex +'/deviceIndex',actDeviceIndex);
		Property.setSavedProperty('devices/'+baseDSID+'/generalSettings/' + iIndex +'/bank',actBank);
		Property.setSavedProperty('devices/'+baseDSID+'/generalSettings/' + iIndex +'/index',actIndex);
		
	}
	return oObject;
	
	
} 



function fetchFavorites(baseDSID) {
	lInfo.logln(' --  fetchFavorites ' + baseDSID);
	
	var oObject=[];
	
	for (var iIndex=0;iIndex<7;iIndex++) {
		//fetchFavorite(baseDSID,iIndex);
		
		oObject.push({
			type:'readNibble',
			dsid:baseDSID,
			bank:127,
			index:149 + iIndex,
			cachePath:'devices/'+baseDSID+'/favorite/' + iIndex +'/button',
			cachePathLow:'devices/'+baseDSID+'/favorite/' + iIndex +'/screen'
		});
		
	}
	for (var iIndex=0;iIndex<7;iIndex++) {
		oObject.push({
			type:'readDataBlock',
			dsid:baseDSID,
			bank:127,
			index:156+(iIndex*12),
			cachePath:'devices/'+baseDSID+'/favorite/' + iIndex +'/name',
			length:12
		});
	}
	
	return oObject;

}

function fetchOneScreens(dSID,baseDSID,iIndex) {

	lInfo.logln(' --  fetchOneScreen ' + dSID);

	Property.setSavedProperty('devices/'+baseDSID+'/' + iIndex +'/dSID',dSID);

	var oObject=[{
				type:'read',
				dsid:dSID,
				bank:127,
				index:0,
				cachePath:'devices/'+baseDSID+'/' + iIndex +'/screenType'
			},{
				type:'read',
				dsid:dSID,
				bank:127,
				index:1,
				cachePath:'devices/'+baseDSID+'/' + iIndex +'/buttonType'
			},{
				type:'readDataBlock',
				dsid:dSID,
				bank:127,
				index:2,
				cachePath:'devices/'+baseDSID +'/' + iIndex+'/buttonName1',
				length:12
			},{
				type:'readDataBlock',
				dsid:dSID,
				bank:127,
				index:14,
				cachePath:'devices/'+baseDSID +'/' + iIndex+'/buttonName5',
				length:12
			},{
				type:'readDataBlock',
				dsid:dSID,
				bank:127,
				index:26,
				cachePath:'devices/'+baseDSID +'/' + iIndex+'/buttonName7',
				length:12
			},{
				type:'readDataBlock',
				dsid:dSID,
				bank:127,
				index:38,
				cachePath:'devices/'+baseDSID +'/' + iIndex+'/buttonName9',
				length:12
			}];
	
	return oObject;
}

function fetchAllScreens(dsid) {
	try {
		if (raisedEvent.parameter.forced==null) {
			if (Property.getNode('devices/' + dsid)!=null) {
				//lInfo.logln(' device is known, skip readout! ');
				return [];
			}
		}
		
		var oArray=[];
		
		lInfo.logln(' --  fetchAllScreens ' + dsid);
		var baseDSID=dsid;
		Property.setSavedProperty('devices/'+baseDSID+'/id',baseDSID);
		
		
		var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
	
		var parentDSID=baseDSID.substring(0,baseDSID.length-3);
				
		for (var iIndex=0;iIndex<8;iIndex++) {
			dSID=parentDSID + '' + (baseIndex+iIndex).toString(16) + "00";			
			oArray=oArray.concat(fetchOneScreens(dSID,baseDSID,iIndex));		
		}		
		var dSID=parentDSID + '' + (baseIndex+7).toString(16) + "00";
		
		for (var iIndex=0;iIndex<8;iIndex++) {
			if (Property.getNode('devices/'+baseDSID+'/' + iIndex + '/keepInSync')==null)
				Property.setSavedProperty('devices/'+baseDSID+'/' + iIndex + '/keepInSync',true);
			oArray.push({
				type:'read',
				dsid:dSID,
				bank:127,
				index:127+iIndex,
				cachePath:'devices/'+baseDSID+'/' + iIndex +'/order'				
			});						
		}
		oArray=oArray.concat(fetchFavorites(baseDSID));
		oArray=oArray.concat(fetchGeneralSettings(baseDSID));
		return oArray;
	} catch (e) {
		lWarn.logln("error: " + e);
	}
	return [];
}

function setButtonText(dsid,buttonNr,text) {
	var fHasWritten=false;
	var sWroteText="";	
	var baseNode=null;
	var baseArray=Property.getNode('devices').getChildren();
	for (var iIndex=0;iIndex<baseArray.length;iIndex++) {
		var subArray=baseArray[iIndex].getChildren();
		for (var jIndex=0;jIndex<subArray.length;jIndex++) {
			if (subArray[jIndex].getChild('dSID')!=null)
				if (subArray[jIndex].getChild('dSID').getValue()==dsid) {
					baseNode=subArray[jIndex].getChild('buttonName' + buttonNr);
				}
					
		}
	}
	var iOffset=2;
	switch (buttonNr) {
		case 1:
			iOffset=2;
		break;
		case 5:
			iOffset=14;			
		break;
		case 7:
			iOffset=26;
		break;
		case 9:
			iOffset=38;
		break;
	}
	
	while (text.length<12)
		text=text + ' ';
	
	var oObject=[{
		type:'writeTextBlock',
		dsid:dsid,
		bank:127,
		index:iOffset,
		cachePath:baseNode.getPath(),
		length:12,
		value:text
	}];
	
	return oObject;
}

function setFavoriteText(dsid,favID,text) {
	
	while (text.length<12)
		text=text + ' ';
	
	var oObject=[{
		type:'writeTextBlock',
		dsid:dsid,
		bank:127,
		index:156+(favID*12),
		cachePath:"devices/" + dsid + "/favorite/" + favID + "/name",
		length:12,
		value:text,
		meta:'favorite'
	}];
	return oObject;
}


function setFavorite(sValue) {
	var oObject=[];
    var oParameterObject = JSON.parse(unescape(sValue));
    var baseID=oParameterObject.basedSID
    //var oDevice=getDevices().byDSUID(baseID);
    for (var iIndex=0;iIndex<7;iIndex++) {
        var baseNode=Property.getNode('devices/' + baseID + '/favorite/' + iIndex);
        oObject.push({
			type:'writeNibble',
			dsid:baseID,
			bank:127,
			index:149 + iIndex,
			cachePath:baseNode.getPath() + '/button',
			cachePathLow:baseNode.getPath() + '/screen',
			valueHigh:oParameterObject.favoriteConfig["favorite" + (iIndex+1)].targetButton,
			valueLow:oParameterObject.favoriteConfig["favorite" + (iIndex+1)].targetScreen,
			meta:'favorite'
		});
        
    	oObject=oObject.concat(setFavoriteText(baseID,iIndex,oParameterObject.favoriteConfig["favorite" + (iIndex+1)].name));
    }
    return oObject;
}

function putAction(targetPath,actionDef,buttonClick,dsid) {
	
	var oAction={
		id:'thanos' + dsid + '.' + buttonClick,
		name:escape('Thanos-App defined Action'),
		delay:0,
		scope:'thanos',
		persistentScope:true,
        conditions: {
            "enabled"    : true,
            "weekdays"   : null,
            "timeframe"  : null,
            "zoneState"  : null,
            "systemState": null,
            "addonStates": null
        },
		triggers:[{
			"type" : "device-msg",
			"dsuid" :dsid,
			"msg" :buttonClick
		}],
		actions: actionDef
	};
	new Event('system-addon-scene-responder.config',{actions:'save',value:JSON.stringify(oAction)}).raise();
}

function resetSRForDSID(dsid) {
	var IDArray=['thanos' + dsid + '.0',
	             'thanos' + dsid + '.1',
	             'thanos' + dsid + '.2',
	             'thanos' + dsid + '.3'];
	new Event('system-addon-scene-responder.config',{
		actions:'delete',
		id:JSON.stringify(IDArray)
	}).raise();
}

function setScreen(sValue) {
	   try {
	        var oParameterObject = JSON.parse(unescape(sValue));
	        var baseID=oParameterObject.basedSID
	        
	        var baseNode=Property.getNode('devices/' + baseID);
	        Property.setSavedProperty(baseNode.getPath()+"/modified",Math.floor(new Date().getTime()/1000));
	        
	        var oDeviceNode;
	        var targetDSID=oParameterObject.dSID;
	        var oObject=[];
	        if (oParameterObject.dSID==-1) {
	        	return setFavorite(sValue);
	        } 
	        if (oParameterObject.dSID==null) {
	        	lInfo.logln('Adding a new Screen...');
	        	var leastOrder=256;
	        	for (var iIndex=0;iIndex<8;iIndex++) {        			
    				if (Property.getNode('/apartment/zones/zone0/devices/' + baseNode.getChild(""+iIndex).getChild("dSID").getValue())==null) {        					
    					var oDeviceNodeTemp=baseNode.getChild(""+iIndex);
    					if (leastOrder>oDeviceNodeTemp.getChild('order').getValue()) {
    						targetDSID=oDeviceNodeTemp.getChild('dSID').getValue();
    						leastOrder=oDeviceNodeTemp.getChild('order').getValue();
    						oDeviceNode=oDeviceNodeTemp;
    					}
    				}    	        			
	        	}
	        	
	        	
	        	if (targetDSID==null) {
	        		lWarn.logln('no further screens avaible!');
	        		new Event('thanos.saved',{error:true,errorCode:1,baseDSID:baseID}).raise();
	        		return [];
	        	}
	        } else {
	        	lInfo.logln('get Screen for ' + oParameterObject.dSID);
	        	for (var iIndex=0;iIndex<8;iIndex++) {
        			if (oDeviceNode==null)
        				if (baseNode.getChild(""+iIndex+"/dSID").getValue()==oParameterObject.dSID)
    	        			oDeviceNode=baseNode.getChild(""+iIndex);
	        	}	        
	        }
	        if (targetDSID!=baseID)
	        	setDeviceVisibility(targetDSID,true);
	        
	        resetSRForDSID(targetDSID);
	        
	        var oDevice=getDevices().byDSUID(targetDSID);
	        if (oParameterObject.buttonTypeConfig.group==null) {
	        	lInfo.logln('configurating a app taster');
	        	
	        	oObject.push({
	    			type:'writeNibble',
	    			dsid:targetDSID,
	    			bank:3,
	    			index:1,
	    			cachePath:oDeviceNode.getPath() + '/screenType',
	    			cachePathLow:oDeviceNode.getPath() + '/buttonType',
	    			valueHigh:8,
	    			valueLow:15
	    		});
	        	
		        if (oParameterObject.buttons.button1.actions!=null) 
			        if (oParameterObject.buttons.button1.actions.length>0) {
			        	lInfo.logln('putting action1 ' + JSON.stringify(oParameterObject.buttons.button1.actions));
			        	putAction(oDeviceNode.getPath()  + '/action1' ,oParameterObject.buttons.button1.actions,0,targetDSID);
			        } 
		        
		        if (oParameterObject.buttons.button2.actions!=null) 
			        if (oParameterObject.buttons.button2.actions.length>0) {
			        	lInfo.logln('putting action2 ' + JSON.stringify(oParameterObject.buttons.button2.actions));
			        	putAction(oDeviceNode.getPath()  + '/action2' ,oParameterObject.buttons.button2.actions,1,targetDSID);
			        } 
		        
		        if (oParameterObject.buttons.button3.actions!=null) 
		        	if (oParameterObject.buttons.button3.actions.length>0){
			        	lInfo.logln('putting action3 ' + JSON.stringify(oParameterObject.buttons.button3.actions));
			        	putAction(oDeviceNode.getPath()  + '/action3' ,oParameterObject.buttons.button3.actions,2,targetDSID);		        	
			        } 
		        
		        if (oParameterObject.buttons.button4.actions!=null) 
		        	if (oParameterObject.buttons.button4.actions.length>0) {
			        	lInfo.logln('putting action4 ' + JSON.stringify(oParameterObject.buttons.button4.actions));
			        	putAction(oDeviceNode.getPath()  + '/action4' ,oParameterObject.buttons.button4.actions,3,targetDSID);
			        }
		        
		        oObject=oObject.concat(setButtonText(targetDSID,1,(oParameterObject.buttons.button1.name)));
		        oObject=oObject.concat(setButtonText(targetDSID,5,(oParameterObject.buttons.button2.name)));
		        oObject=oObject.concat(setButtonText(targetDSID,7,(oParameterObject.buttons.button3.name)));
		        oObject=oObject.concat(setButtonText(targetDSID,9,(oParameterObject.buttons.button4.name)));

	        	oDevice.setJokerGroup(8);
	        	oDevice.setButtonID(15)

	        } else {
	        	lInfo.logln('configurating a scene taster');
		        
	        	if (oDevice.getPropertyNode().getChild('ZoneID').getValue()==oParameterObject.buttonTypeConfig.zone) {
	        		lInfo.logln('Device is allready in Zone');
	        	} else {
	        		lInfo.logln('change zone');
		        	var zone = getZoneByID(oParameterObject.buttonTypeConfig.zone);
		        	lInfo.logln('got zone ' + zone);
		        	zone.addDevice(targetDSID);
		        	lInfo.logln('add device to zone ' + targetDSID);
	        	}
	        	lInfo.logln('set joker ID ' + oParameterObject.buttonTypeConfig.group);
	        	oDevice.setJokerGroup(oParameterObject.buttonTypeConfig.group);
	        	lInfo.logln('set button ID ' + oParameterObject.buttonTypeConfig.button);
	        	oDevice.setButtonID(oParameterObject.buttonTypeConfig.button);
	        	lInfo.logln('ready');
		        
		        oObject.push({
	    			type:'writeNibble',
	    			dsid:targetDSID,
	    			bank:3,
	    			index:1,
	    			cachePath:oDeviceNode.getPath() + '/screenType',
	    			cachePathLow:oDeviceNode.getPath() + '/buttonType',
	    			valueHigh:oParameterObject.buttonTypeConfig.group,
	    			valueLow:oParameterObject.buttonTypeConfig.button
	    		});
		        
		        if (!oParameterObject.keepInSync) {
			        oObject=oObject.concat(setButtonText(targetDSID,1,oParameterObject.sceneNames.scene1));
			        oObject=oObject.concat(setButtonText(targetDSID,5,oParameterObject.sceneNames.scene2));
			        oObject=oObject.concat(setButtonText(targetDSID,7,oParameterObject.sceneNames.scene3));
			        oObject=oObject.concat(setButtonText(targetDSID,9,oParameterObject.sceneNames.scene4));
		        } else {
		        	new Event('thanos.config',{actions:'syncSceneNames'}).raise();
		        }
		        Property.setSavedProperty(oDeviceNode.getPath() + '/keepInSync',oParameterObject.keepInSync);
	        }
	        
	        return oObject;
	        
	   }
	   catch (e) {
		   lWarn.logln('Error ' + e);
	   }
	   return [];
}

function removeScreen(idValues) {
	try {

		var oIDObject=JSON.parse(unescape(idValues));
        var oPropertyBase=Property.getNode('devices').getChildren();
	    var oArray=[];
	    var oOrders={};
	    lInfo.logln('moving screens at the end!')
        for (var iIndex=0;iIndex<oPropertyBase.length;iIndex++) {
        	var baseDSID=oPropertyBase[iIndex].getName();
        	oOrders[baseDSID]=[];        	
        	lInfo.logln('base dsid ' + baseDSID);
        	var orderDSID=Property.getNode(oPropertyBase[iIndex].getPath()+'/7/dSID').getValue();
        	lInfo.logln('order dsid ' + orderDSID);
        	var maxOrder=0;
        	var oShouldBeSet=[];
        	for (var jIndex=0;jIndex<8;jIndex++) {
        		if (Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/order')!=null) 
        			if (Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/order').getValue()>maxOrder)
        				maxOrder=Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/order').getValue();

        		lInfo.logln('sub dsid ' + subDSID);
        		var subDSID=Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/dSID').getValue();        	
        		if (oIDObject.indexOf(subDSID)>-1)
        			oShouldBeSet.push(jIndex);
        	}
        	lInfo.logln('max order will be' + maxOrder);
        	if (oShouldBeSet.length>0) {
        		for (var kIndex=0;kIndex<oShouldBeSet.length;kIndex++) {
        			maxOrder++;
                	lInfo.logln('set device ' + oShouldBeSet[kIndex] + ' from ' + orderDSID + ' to ' + maxOrder);
        			setDeviceConfig(orderDSID,127,127+oShouldBeSet[kIndex],maxOrder);
        			Property.setProperty(oPropertyBase[iIndex].getPath()+'/'+oShouldBeSet[kIndex]+'/order',maxOrder);        			
        		}
        	}            	
        }	 	   

	    
	    for (var sKey in oIDObject) {
	        var dsid=(oIDObject[sKey]);
	    	lInfo.logln('removing screen ' + dsid);
	    	resetSRForDSID(dsid);
	    	setDeviceVisibility(dsid,false);
	        for (var iIndex=0;iIndex<oPropertyBase.length;iIndex++) {	        	
	        	var baseDSID=oPropertyBase[iIndex].getName();
	        	for (var jIndex=0;jIndex<8;jIndex++) {
	        		var subDSID=Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/dSID').getValue();
	        		if (Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/dSID').getValue()==dsid) {
	        			for (var kIndex=0;kIndex<oOrders[baseDSID].length;kIndex++) {
	        				if (oOrders[baseDSID][kIndex].dsid==dsid)
	        					oOrders[baseDSID][kIndex].order=-1;
	        			}
	        	        oArray.push({
	        				type:'writeNibble',
	        				dsid:dsid,
	        				bank:0x03,
	        				index:0x01,
	        				cachePath:oPropertyBase[iIndex].getPath()+'/' + jIndex + '/buttonType',
	        				cachePathLow:oPropertyBase[iIndex].getPath()+'/' + jIndex + '/screenType',
	        				valueHigh:0,
	        				valueLow:0
	        			});
	        		}	        	
	        	}
	        	
	        }
	    }
	   
		if (oArray.length>0) {
			oArray[oArray.length-1].finishEvent='thanos.config';
			oArray[oArray.length-1].finishEventParameter='{"actions":"normalizeOrder"}';
		}
	    
		new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oArray)}).raise();
		
	    new Event('thanos.saved',{}).raise();
	} catch (e) {
		lWarn.logln('error ' + e);
	}
}

function checkAndReadout(dsid) {
	if (dsid!=null) {
		if (Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/productInfo/EAN') !=null) {
			var ean=Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/productInfo/EAN').getValue();
			if ( (ean=='4251161900029') || (ean=='4251161900012') ){
				if ((parseInt(dsid.substring(dsid.length-3).substring(0,1),16)%8)!=0) {
					;//lInfo.logln('device is a subdevice, not main device');				
				} else {
					if (Property.getNode('fetching/' + dsid)==null) {
						lInfo.logln('enqueue a fetch for ' + dsid);
						new Event('thanos.config',{dsid:dsid,actions:'fetchAllScreens'}).raise();					
					} else
						lInfo.logln('skip fetch for ' + dsid);
					Property.setProperty('fetching/' + dsid,true);
				}
						
			}
		}
		return;
	}
		
	var oArray=Property.getNode('/apartment/zones/zone0/devices').getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {	
		var ean=oArray[iIndex].getChild('productInfo/EAN').getValue();
		var baseDSID=oArray[iIndex].getName();
		if (ean=='4251161900029') {
			lInfo.logln('got EAN ' + ean + ' for ' + oArray[iIndex].getName());
			if ((parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)%8)!=0) {
				;//lInfo.logln('device is a subdevice, not main device');				
			} else {
				if (Property.getNode('fetching/' + oArray[iIndex].getName())==null) {
					lInfo.logln('enqueue a fetch for ' + oArray[iIndex].getName());
					new Event('thanos.config',{dsid:oArray[iIndex].getName(),actions:'fetchAllScreens'}).raise();					
				} else
					lInfo.logln('skip fetch for ' + oArray[iIndex].getName());
				Property.setProperty('fetching/' + oArray[iIndex].getName(),true);
			}
				
		}	
		if (ean=='4251161900012') {
			lInfo.logln('got EAN ' + ean + ' for ' + oArray[iIndex].getName());
			if ((parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)%8)!=0) {
				;//lInfo.logln('device is a subdevice, not main device');				
			} else {
				if (Property.getNode('fetching/' + oArray[iIndex].getName())==null) {
					lInfo.logln('enqueue a fetch for ' + oArray[iIndex].getName());
					new Event('thanos.config',{dsid:oArray[iIndex].getName(),actions:'fetchAllScreens'}).raise();
				} else
					lInfo.logln('skip fetch for ' + oArray[iIndex].getName());

				Property.setProperty('fetching/' + oArray[iIndex].getName(),true);
			}
		}
	}
}


function getParam(baseNode,deviceIndex,bank,index) {
	var oArray=baseNode.getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		if (oArray[iIndex].getChild('deviceIndex').getValue()==deviceIndex)
			if (oArray[iIndex].getChild('bank').getValue()==bank)
				if (oArray[iIndex].getChild('index').getValue()==index){
					return oArray[iIndex];
				}
					
	}
	return null;
}

function setDeviceParameter() {
	lInfo.logln('setDeviceParameter for ' + raisedEvent.parameter.dsid + ' with ' +unescape(raisedEvent.parameter.values));
	var oValues=JSON.parse(unescape(raisedEvent.parameter.values));
	var baseNode=Property.getNode('devices/' + raisedEvent.parameter.dsid + '/generalSettings');
	if (baseNode==null) {
		lWarn.logln('no cached values!');
		return [];
	}
	var shouldWrite=[];
	for (var iIndex=0;iIndex<oValues.length;iIndex++) {
		var fShoudSave=false;
		var oValue=oValues[iIndex];
		var newValue=oValues[iIndex].value;
		var oldNode=getParam(baseNode,oValue.deviceIndex,oValue.bank,oValue.index);
		if (oldNode!=null) {
			var oldValue=oldNode.getChild('value').getValue();
			if (oldNode.getChild('newvalue')!=null)
				oldValue=oldNode.getChild('newvalue').getValue();
			
			if (oValues[iIndex].bitmask!=null) {
				if (oValues[iIndex].value == true) {
					//lInfo.logln('bitmask ' + (oldValue & oValues[iIndex].bitmask));
					if ((oldValue & oValues[iIndex].bitmask) > 0)
						;//lInfo.logln('old: bit set, new: bit set');
					else {
						//lInfo.logln('old: bit not set, new: bit set');
						fShoudSave=true;
						newValue=oldValue | oValues[iIndex].bitmask;
					}
				} else {
					if ((oldValue & oValues[iIndex].bitmask) > 0) {
						//lInfo.logln('old: bit set, new: bit not set');
						fShoudSave=true;
						newValue=oldValue ^ oValues[iIndex].bitmask;
					} else {
						;//lInfo.logln('old: bit not set, new: bit not set');					
					}
				} 
			} else {
				if (oldValue!=newValue) {
					fShoudSave=true;
				}
			}
			if (fShoudSave) {
				Property.setProperty(oldNode.getPath() + '/newvalue',newValue);
				lInfo.logln('SET old value ' + oldValue + ' to ' + newValue + ' - '+ JSON.stringify(oValue) + ' notfied in ' + oldNode.getPath());
				shouldWrite.push(oldNode.getPath());
			} else
				lInfo.logln('Skip old value ' + oldValue + ' to ' + newValue + ' - '+ JSON.stringify(oValue));
		}
	}
	var oObject=[];
	for (var iIndex=0;iIndex<shouldWrite.length;iIndex++) {
		if (Property.getNode(shouldWrite[iIndex]+'/newvalue')!=null) {
			var deviceIndex=Property.getProperty(shouldWrite[iIndex]+'/deviceIndex');
			var bank=Property.getProperty(shouldWrite[iIndex]+'/bank');
			var index=Property.getProperty(shouldWrite[iIndex]+'/index');
			var value=Property.getProperty(shouldWrite[iIndex]+'/newvalue');

			lInfo.logln('Now write data at ' + shouldWrite[iIndex] + ' to ' + value);
			
			var baseDSID=raisedEvent.parameter.dsid;
			var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
			var parentDSID=baseDSID.substring(0,baseDSID.length-3);
			
			var dSID=parentDSID + '' + (baseIndex+deviceIndex).toString(16) + "00";			
			
			Property.getNode(shouldWrite[iIndex]).removeChild('newvalue');
			
			oObject.push({
				type:'write',
				dsid:dSID,
				bank:bank,
				index:index,
				value:value,
				cachePath:shouldWrite[iIndex] +'/value',
				meta:'general'
			});
			
		}
	}
	if (oObject.length==0)
		new Event('thanos.saved',{}).raise();
	else {
		oObject[oObject.length-1].finishEvent='thanos.config';
		oObject[oObject.length-1].finishEventParameter='{"actions":"finish"}';
	}
	return oObject;
}

function registerSpecialDevices() {
	
	if (Property.getNode('devices')==null)
		return;
	var oArray=Property.getNode('devices').getChildren();
	var ergArray=[];
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var oSubArray=oArray[iIndex].getChildren();
		for (var jIndex=0;jIndex<oSubArray.length;jIndex++)
			if (oSubArray[jIndex].getChild('dSID')!=null)
				if (oSubArray[jIndex].getChild('screenType')!=null) 
					if (oSubArray[jIndex].getChild('screenType').getValue()==8) {					
						var dSID=oSubArray[jIndex].getChild('dSID').getValue();
						if (Property.getNode('/apartment/zones/zone0/devices/' + dSID)!=null) {
							lInfo.logln('joh checl');
							var button1=Utf8.decode(oSubArray[jIndex].getChild('buttonName1').getValue());
							var button5=Utf8.decode(oSubArray[jIndex].getChild('buttonName5').getValue());
							var button7=Utf8.decode(oSubArray[jIndex].getChild('buttonName7').getValue());
							var button9=Utf8.decode(oSubArray[jIndex].getChild('buttonName9').getValue());
							ergArray.push({
								dsid:dSID,
								triggers:{
									'device':[
									    {id:0,name:{de_DE:button1}},
									    {id:1,name:{de_DE:button5}},
									    {id:2,name:{de_DE:button7}},
									    {id:3,name:{de_DE:button9}}]
								}
							});
						}
					} 
	}
	new Event('system-addon-scene-responder.registerSpecialDSIDDevices',{
		_context:'thanos',
		values:JSON.stringify(ergArray)
	}).raise();
}

function syncOneSceneName(deviceNode,fillEmpty) {
	var oArrayNames=[];
	if (deviceNode.getChild('buttonType')==null)
		return [];
	if (deviceNode.getChild('keepInSync')==null)
		return [];
	if (deviceNode.getChild('keepInSync').getValue()==false)
		return [];
	
	var buttonType=deviceNode.getChild('buttonType').getValue();
	if (buttonType==0)
		return [];
	if (buttonType==15)
		return [];
	if (buttonType==14)
		return [];
					
	var dSID=deviceNode.getChild('dSID').getValue();
						
	if (Property.getNode('/apartment/zones/zone0/devices/' + dSID)==null)
		return [];
				
	var oDeviceNode=Property.getNode('/apartment/zones/zone0/devices/' + dSID);
	var zoneID=oDeviceNode.getChild('ZoneID').getValue();
	var groupID=deviceNode.getChild('screenType').getValue();
	if (groupID==0)
		return [];
	if (groupID==48)
		return [];
	if (groupID==8)
		return [];
	var fSkip=false;
	var targetScene=-1;
	if (raisedEvent.parameter.zone !=null)
		if (raisedEvent.parameter.group!=null)
			if (raisedEvent.parameter.sceneId !=null)
				if (raisedEvent.parameter.newSceneName !=null) {
					targetScene=raisedEvent.parameter.sceneId;
					lInfo.logln('maybe skippable! ' + zoneID+ ' != ' +raisedEvent.parameter.zone);
					lInfo.logln('maybe skippable! ' + groupID+ ' != ' +raisedEvent.parameter.group);
					if (zoneID!=raisedEvent.parameter.zone)
						fSkip=true;
					if (groupID!=raisedEvent.parameter.group)
						fSkip=true;
				}
	if (fSkip)
		return [];
	var button1=null;
	var button2=null;
	var button3=null;
	var button4=null;
	if (fillEmpty) {
		button1="Scene 1";
		button2="Scene 2";
		button3="Scene 3";
		button4="Scene 4";
	}
	var path1="";
	var path2="";
	var path3="";
	var path4="";
	switch (buttonType) {
		case 1:
			path1="scene6";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=6)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 2:
			path1="scene7";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=7)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 3:
			path1="scene8";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=8)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 4:
			path1="scene9";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=9)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 5:
			path1="scene5";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=5)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																

		break;
		case 6:
			path1="scene33";
			path2="scene20";
			path3="scene21";
			path4="scene22";
			if (targetScene!=-1) {
				if (targetScene!=33)
					path1="";
				if (targetScene!=20)
					path2="";
				if (targetScene!=21)
					path3="";
				if (targetScene!=22)
					path4="";
			}																

		break;
		case 7:
			path1="scene35";
			path2="scene23";
			path3="scene24";
			path4="scene25";
			if (targetScene!=-1) {
				if (targetScene!=35)
					path1="";
				if (targetScene!=23)
					path2="";
				if (targetScene!=24)
					path3="";
				if (targetScene!=25)
					path4="";
			}																
		break;
		case 8:
			path1="scene37";
			path2="scene26";
			path3="scene27";
			path4="scene28";
			if (targetScene!=-1) {
				if (targetScene!=37)
					path1="";
				if (targetScene!=26)
					path2="";
				if (targetScene!=27)
					path3="";
				if (targetScene!=28)
					path4="";
			}																
		break;
		case 9:
			path1="scene39";
			path2="scene29";
			path3="scene30";
			path4="scene31";
			if (targetScene!=-1) {
				if (targetScene!=39)
					path1="";
				if (targetScene!=29)
					path2="";
				if (targetScene!=30)
					path3="";
				if (targetScene!=31)
					path4="";
			}																
		break;
		case 10:
			path1="scene6";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=6)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																

		break;
		case 11:
			path1="scene7";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=7)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 12:
			path1="scene8";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=8)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																
		break;
		case 13:
			path1="scene9";
			path2="scene17";
			path3="scene18";
			path4="scene19";
			if (targetScene!=-1) {
				if (targetScene!=9)
					path1="";
				if (targetScene!=17)
					path2="";
				if (targetScene!=18)
					path3="";
				if (targetScene!=19)
					path4="";
			}																

		break;

	}
	if (path1!="") {
		button1="Scene 1";
		if (Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path1+'/name')!=null)
			if (Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path1+'/name').getValue())!="")
				button1=Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path1+'/name').getValue());
	}
	if (path2!="") {
		button2="Scene 2";
		if (Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path2+'/name')!=null)
			if (Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path2+'/name').getValue())!="")
				button2=Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path2+'/name').getValue());
	}
	if (path3!="") {
		button3="Scene 3";
		if (Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path3+'/name')!=null)
			if (Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path3+'/name').getValue())!="")
				button3=Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path3+'/name').getValue());
	}
	if (path4!="") {
		button4="Scene 4";
		if (Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path4+'/name')!=null)
			if (Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path4+'/name').getValue())!="")
				button4=Utf8.decode(Property.getNode('/apartment/zones/zone'+zoneID+'/groups/group' + groupID + '/scenes/'+path4+'/name').getValue());
	}
	if (button1!=null) {
		lInfo.logln('info for ' + dSID + ' zone ' + zoneID + ' group ' + groupID + ':' +button1 );
		oArrayNames=oArrayNames.concat(setButtonText(dSID,1,button1));
	}
	if (button2!=null) {
		lInfo.logln('info for ' + dSID + ' zone ' + zoneID + ' group ' + groupID + ':' +button2 );
		oArrayNames=oArrayNames.concat(setButtonText(dSID,5,button2));
	}
	if (button3!=null) {
		lInfo.logln('info for ' + dSID + ' zone ' + zoneID + ' group ' + groupID + ':' +button3 );
		oArrayNames=oArrayNames.concat(setButtonText(dSID,7,button3));
	}													
	if (button4!=null) {
		lInfo.logln('info for ' + dSID + ' zone ' + zoneID + ' group ' + groupID + ':' +button4 );
		oArrayNames=oArrayNames.concat(setButtonText(dSID,9,button4));
	}
	return oArrayNames;
}

function syncSceneNames(dsid,fillEmpty) {
	if (fillEmpty==null)
		fillEmpty=false;
	if (dsid==null)
		lInfo.logln('Syncing all scenenames!');
	else {
		lInfo.logln('Syncing scenenames for check for device ' + dsid);
		if (raisedEvent.parameter.configClass!=null)
			if (raisedEvent.parameter.configIndex!=null)
				if (raisedEvent.parameter.configClass==127) {
					if ((raisedEvent.parameter.configIndex>=2) && (raisedEvent.parameter.configIndex<50)) {
						lInfo.logln('configure events comes from text write, ignore sync therefore');
						return;
					}
					if (raisedEvent.parameter.configIndex>=149) {
						lInfo.logln('configure events comes from favorite, ignore sync therefore');
						return;
					}
				}
			
	}
	var oArrayNames=[];
	
	if (Property.getNode('devices')!=null) {
		var oArray=Property.getNode('devices').getChildren();
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			var deviceArray=oArray[iIndex].getChildren();
			for (var jIndex=0;jIndex<deviceArray.length;jIndex++) {
				if (deviceArray[jIndex].getChild('buttonType')!=null) 
					if (deviceArray[jIndex].getChild('dSID')!=null) {					
						if (dsid==null)
							oArrayNames=oArrayNames.concat(syncOneSceneName(deviceArray[jIndex],fillEmpty));
						else if (dsid==deviceArray[jIndex].getChild('dSID').getValue())
							oArrayNames=oArrayNames.concat(syncOneSceneName(deviceArray[jIndex],fillEmpty));
					}
			}
		}
			
	}	
	if (oArrayNames.length>0) {
		lInfo.logln('enqueueing ' + JSON.stringify(oArrayNames));
				
		new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oArrayNames)}).raise();
	} else 
		lInfo.logln('no changes for scenename found');
}

function calibrateTemperature(baseDSID,realValue) {

	lInfo.logln(baseDSID + ' temperature should be set to ' + realValue)
	var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
	var parentDSID=baseDSID.substring(0,baseDSID.length-3);
	
	var dsid=parentDSID + '' + (baseIndex+1).toString(16) + "00";			
	
	var sensorNodes=Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/sensorInputs').getChildren();
	for (var iIndex=0;iIndex<sensorNodes.length;iIndex++) {
		if (sensorNodes[iIndex].getChild('type').getValue()==9) {
			
			var oDeviceSensor=getDevices().byDSUID(dsid);
			
			var actSensorValue=oDeviceSensor.getSensorValue(sensorNodes[iIndex].getChild('index').getValue());
			lInfo.logln('found last temperature ' + actSensorValue + ' on index ' + sensorNodes[iIndex].getChild('index').getValue());
			actSensorValue=actSensorValue - 1726;
			lInfo.logln('found last temperature ' + actSensorValue + ' on index ' + sensorNodes[iIndex].getChild('index').getValue());
			
			var newValue=parseFloat("" + realValue);
			var difference = (newValue * 40) - actSensorValue;
			
			lInfo.logln('difference is ' + (difference/40) );
			
			var param=Math.floor(difference/4);

			var oldParam=getDeviceConfig(baseDSID,127,104);
			
			lInfo.logln('old offset is ' + oldParam);
			
			param=param +oldParam ; // rundungsoffset ....
			
			lInfo.logln('set to ' + param);

			setDeviceConfig(baseDSID,127,104,param);	   

		}
	}		
}

function calibrateHuminity(baseDSID,realValue) {
	var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
	var parentDSID=baseDSID.substring(0,baseDSID.length-3);
	
	var dsid=parentDSID + '' + (baseIndex+1).toString(16) + "00";			
	
	var sensorNodes=Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/sensorInputs').getChildren();
	for (var iIndex=0;iIndex<sensorNodes.length;iIndex++) {
		if (sensorNodes[iIndex].getChild('type').getValue()==13) {
			var actSensorValue=sensorNodes[iIndex].getChild('value').getValue();
			var newValue=parseFloat("" + realValue);
			var difference = newValue - actSensorValue;
			
			var param=Math.floor(difference*10);

			var oldParam=getDeviceConfig(baseDSID,127,105);
			param=param +oldParam;
			
	        setDeviceConfig(baseDSID,127,105,param);	   

		}
	}		
}

function removeObsoleteDevices() {
	lInfo.logln('scan for deleted devices and removing data');
	var fShouldSave=false;
	if (Property.getNode('devices')==null)
		return;
	var oArray=Property.getNode('devices').getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		if (oArray[iIndex].getChild('id')!=null) {
			var dsid=oArray[iIndex].getChild('id').getValue();
			if (Property.getNode('/apartment/zones/zone0/devices/' + dsid)==null){
				lInfo.logln('removing old deviceinfo ' + dsid);
				Property.getNode('devices').removeChild(dsid);
				fShouldSave=true;
			}
		}
	}
	if (fShouldSave)
		Property.store();
}

function normalizeOrder() {

	var oPropertyBase=Property.getNode('devices').getChildren();
    var oArray=[];
    lInfo.logln('normalizeOrder');
    for (var iIndex=0;iIndex<oPropertyBase.length;iIndex++) {
    	var baseDSID=oPropertyBase[iIndex].getName();
    	lInfo.logln('base dsid ' + baseDSID);
    	var orderDSID=Property.getNode(oPropertyBase[iIndex].getPath()+'/7/dSID').getValue();
    	lInfo.logln('order dsid ' + orderDSID);
    	var oShouldBeSet=[];
    	for (var jIndex=0;jIndex<8;jIndex++) {
    		oShouldBeSet.push({
    			index:jIndex,
    			order:Property.getNode(oPropertyBase[iIndex].getPath()+'/' + jIndex + '/order').getValue()
    		});
    	}
    	
    	oShouldBeSet=oShouldBeSet.sort(function (o1,o2) {
    		return o1.order-o2.order
    	});
    	
    	lInfo.logln('order should be set to ' + JSON.stringify(oShouldBeSet));
    	
    	for (var jIndex=0;jIndex<oShouldBeSet.length;jIndex++) 
	    	oArray.push({
				type:'write',
				dsid:orderDSID,
				bank:127,
				index:127+oShouldBeSet[jIndex].index,
				cachePath:oPropertyBase[iIndex].getPath()+'/'+oShouldBeSet[jIndex].index+'/order',
				value:jIndex+1
			});    	            
    }	 	   
	return oArray;
}

function changeOrder(dsid1,dsid2) {
	var path1;
	var path2;
	var basePath1;
	var basePath2;
	
	var baseDevices=Property.getNode('devices').getChildren();
	for (var iIndex=0;iIndex<baseDevices.length;iIndex++) {
		var baseDevicePath=baseDevices[iIndex].getPath();	
		for (var jIndex=0;jIndex<8;jIndex++) {
			if (Property.getNode(baseDevicePath + '/' + jIndex + '/dSID').getValue()==dsid1) {
				path1=jIndex;
				basePath1=baseDevicePath;
			}
			if (Property.getNode(baseDevicePath + '/' + jIndex + '/dSID').getValue()==dsid2) {
				path2=jIndex;
				basePath2=baseDevicePath;
			}
		}		
	}
	if (path1!=null)
		if (path2!=null) 	
			if (basePath1==basePath2) {
				var order1=parseInt('' + Property.getNode(basePath1 + '/' + path1 + '/order').getValue());
				var order2=parseInt('' + Property.getNode(basePath1 + '/' + path2 + '/order').getValue());
				lInfo.logln('found path ' +  basePath1 + ' on dev ' + path1 + ' set ' + order2);
				lInfo.logln('found path ' +  basePath1 + ' on dev ' + path2 + ' set ' + order1);
				
				var dsid=Property.getNode(basePath1 + '/7/dSID').getValue();
		        setDeviceConfig(dsid,127,127+path1,order2);	   
		        setDeviceConfig(dsid,127,127+path2,order1);	   
				
				Property.setSavedProperty(basePath1 + '/' + path1 + '/order',order2);
				Property.setSavedProperty(basePath1 + '/' + path2 + '/order',order1);
			}
	
	
	new Event('thanos.saved',{}).raise();
	Property.store();
}

lInfo.logln('event ' + raisedEvent.name);
for (var sKey in raisedEvent.parameter) {
	lInfo.logln('parameter ' + sKey + ' ' + raisedEvent.parameter[sKey]);
}
for (var sKey in raisedEvent.source) {
	lInfo.logln('source ' + sKey + ' ' + raisedEvent.source[sKey]);
}

Property.setProperty('system/preventUninstall',false);
Property.setFlag('system/preventUninstall', 'ARCHIVE', true);


if (raisedEvent.name=="running")
	Property.load();
else if (raisedEvent.name=='DeviceEvent') {			
	    checkAndReadout(raisedEvent.source.dsuid);
	    removeObsoleteDevices();
	    syncSceneNames(raisedEvent.source.dsuid,(raisedEvent.parameter.action=="moved"));
/*	    var fCanBeUninstalled=true;
	    if (Property.getNode('devices')!=null)
	        if (Property.getNode('devices').getChildren()!=null)
	        	if (Property.getNode('devices').getChildren().length>0)
	        		fCanBeUninstalled=false;
	    if (fCanBeUninstalled) {
		    Property.setProperty('system/preventUninstall',false);
		    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
	    } else {
		    Property.setProperty('system/preventUninstall',true);
		    Property.setFlag('system/preventUninstall', 'ARCHIVE', true);
	    }*/
	   
} else {

	if (raisedEvent.parameter.actions=='resetTemperatureSensor') {
		if (raisedEvent.parameter.dsid!=null) {
			var baseDSID=raisedEvent.parameter.dsid;
	
			setDeviceConfig(baseDSID,127,104,128);	   
			
			lInfo.logln(baseDSID + ' temperature should be reset')
			var baseIndex=Math.floor(parseInt(baseDSID.substring(baseDSID.length-3).substring(0,1),16)/8)*8;
			var parentDSID=baseDSID.substring(0,baseDSID.length-3);
			
			var dsid=parentDSID + '' + (baseIndex+1).toString(16) + "00";			
			
			var sensorNodes=Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/sensorInputs').getChildren();
			for (var iIndex=0;iIndex<sensorNodes.length;iIndex++) {
				if (sensorNodes[iIndex].getChild('type').getValue()==9) {				
					var oDeviceSensor=getDevices().byDSUID(dsid);				
					var actSensorValue=oDeviceSensor.getSensorValue(sensorNodes[iIndex].getChild('index').getValue());
					lInfo.logln('fetch sensor value to update local values');
				}
			}		
		}
	}
	
	if (raisedEvent.parameter.actions=='calibrateSensor') {
		if (raisedEvent.parameter.dsid!=null) {
			if (raisedEvent.parameter.realTemperature!=null)
				calibrateTemperature(raisedEvent.parameter.dsid,raisedEvent.parameter.realTemperature);
			if (raisedEvent.parameter.realHuminity!=null)
				calibrateHuminity(raisedEvent.parameter.dsid,raisedEvent.parameter.realHuminity);
		}
	}
	
	if (raisedEvent.parameter.actions=='syncSceneNames') {
		syncSceneNames();
	}
	
	if (raisedEvent.parameter.actions=='setOrderDirectly') {
		lInfo.logln('set position ' + raisedEvent.parameter.dsid + ' to ' + raisedEvent.parameter.order );
	
		var path;
		var basePath;
		var order=raisedEvent.parameter.order;
		
		var baseDevices=Property.getNode('devices').getChildren();
		for (var iIndex=0;iIndex<baseDevices.length;iIndex++) {
			var baseDevicePath=baseDevices[iIndex].getPath();	
			for (var jIndex=0;jIndex<8;jIndex++) {
				if (Property.getNode(baseDevicePath + '/' + jIndex + '/dSID').getValue()==raisedEvent.parameter.dsid) {
					path=jIndex;
					basePath=baseDevicePath;
				}
			}		
		}
		if (path!=null){		
			new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify([{
				type:'write',
				dsid:Property.getNode(basePath + '/7/dSID').getValue(),
				bank:127,
				index:127+path,
				value:order,
				cachePath:basePath + '/' + path + '/order'
			}])}).raise();
		}
		new Event('thanos.saved',{}).raise();
		var fStore=true;
		if (raisedEvent.parameter.noStore!=null)
			if (raisedEvent.parameter.noStore=="true")
				fStore=false;
		if (fStore)
			Property.store();
	}
	
	if (raisedEvent.parameter.actions=='setOrder') {
		lInfo.logln('changing position ' + raisedEvent.parameter.dsid1 + ' with ' + raisedEvent.parameter.dsid2 );
		changeOrder(raisedEvent.parameter.dsid1,raisedEvent.parameter.dsid2);
	}
	
	if (raisedEvent.parameter.actions=='registerTrigger') {
		lInfo.logln('register triggers');
		Property.load();
		//updateAllTriggerRegistrations();
		registerSpecialDevices();
	}
	

	if (raisedEvent.parameter.actions=='setScreen') {
		lInfo.logln('values: ' +  unescape(raisedEvent.parameter.value));
		var oObject=setScreen(raisedEvent.parameter.value);
		if (oObject.length>0) {
	        oObject[oObject.length-1].finishEvent='thanos.config';
	        oObject[oObject.length-1].finishEventParameter='{"actions":"finish"}';
			new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
			//updateAllTriggerRegistrations();
		} else new Event('thanos.config',{"actions":"finish"}).raise();
		
	}
	
	if (raisedEvent.parameter.actions=='removeScreen') {
		lInfo.logln('values: ' +  unescape(raisedEvent.parameter.id));
		removeScreen(raisedEvent.parameter.id);
	}
	
	if (raisedEvent.parameter.actions=='fetchGeneralSettings') {
		if (raisedEvent.parameter.dsid!=null) {
			var oObject=fetchGeneralSettings(raisedEvent.parameter.dsid);
			new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
		}
	}
	
	if (raisedEvent.parameter.actions=='fetchAllScreens') {
		if (raisedEvent.parameter.dsid!=null) {
			if (Property.getNode('fetching')!=null)
				Property.getNode('fetching').removeChild(raisedEvent.parameter.dsid);
			var oObject=fetchAllScreens(raisedEvent.parameter.dsid);
			if (oObject.length>0) {
				oObject[oObject.length-1].finishEvent='thanos.config';
				oObject[oObject.length-1].finishEventParameter='{"actions":"syncSceneNames"}';	
				new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
			}
		}
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='fetchOneScreen') {
		if (raisedEvent.parameter.dsid!=null){
			var oObject=fetchOneScreens(raisedEvent.parameter.dsid,raisedEvent.parameter.dsid,0);
			new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
		}
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='fetchFavorites') {
		try {
			if (raisedEvent.parameter.dsid!=null) {
				var oObject=fetchFavorites(raisedEvent.parameter.dsid);
				new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
			}
			Property.store();
		} catch (e) {
			lWarn.logln(e);
		}
	}
	
	if (raisedEvent.parameter.actions=='setButtonText') {
		try {
		if (raisedEvent.parameter.dsid!=null)
			if (raisedEvent.parameter.buttonNr!=null)
				if (raisedEvent.parameter.text!=null) {
					var oObject=setButtonText(raisedEvent.parameter.dsid,parseInt("" + raisedEvent.parameter.buttonNr,10),unescape(raisedEvent.parameter.text));
					new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
				}
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
	}
	
	if (raisedEvent.parameter.actions=='setFavoriteText') {
		try {
		if (raisedEvent.parameter.dsid!=null)
			if (raisedEvent.parameter.favorite!=null)
				if (raisedEvent.parameter.text!=null) {
					var oObject=setFavoriteText(raisedEvent.parameter.dsid,parseInt("" + raisedEvent.parameter.favorite,10),unescape(raisedEvent.parameter.text));
					new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
				}
		} catch (e) {
			lWarn.logln('Error ' + e);
		}
	}
	
	if (raisedEvent.parameter.actions=='setDeviceParameter') {	
		if (raisedEvent.parameter.dsid!=null)
			if (raisedEvent.parameter.values!=null) {
				var oObject=setDeviceParameter();
				new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oObject)}).raise();
			}
	}
	
	if (raisedEvent.parameter.actions=='finish') {
		lInfo.logln('Issue a finish Event!');
		registerSpecialDevices();
		new Event('thanos.saved',{}).raise();
		Property.store();
	}
	
	if (raisedEvent.parameter.actions=='registerSpecialDSIDDevices') {
		registerSpecialDevices();
	}
	
	if (raisedEvent.parameter.actions=='normalizeOrder') {
		var oArray=normalizeOrder();
		new Event('thanos.queue',{actions:'enqueue',values:JSON.stringify(oArray)}).raise();
		
	}
	
	if (raisedEvent.parameter.actions=='resetToDefault') {
		try {
			if (raisedEvent.parameter.dsid!=null) {
				if (Property.getNode('devices/'+raisedEvent.parameter.dsid + '/7/dSID')!=null) {
					
					var dsid=Property.getNode('devices/'+raisedEvent.parameter.dsid + '/7/dSID').getValue();
					setDeviceConfig(dsid,126, 0x1f,255);	
					setDeviceConfig(dsid,127, 0xEF,255);			
					new Event('thanos.saved',{}).raise();
					Property.store();			
				}
			}			
		} catch (e) {
			lWarn.logln('Error ' + e);
		}	
	}
	
	if (raisedEvent.parameter.actions=='removeObsoleteDevices') {
		removeObsoleteDevices();
	}
}
