Ext.define('DSS.addon.ScreenTypeSelectorFavorite', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return 240;
	},
	baseStore : null,
	height : '100%',
	initStores : function () {
		if (Ext.data.StoreManager.lookup('screentype-favoritestore') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-favoritestore',
				fields : [ '_id', 'defaultname', 'screen', 'button', 'name', 'type', 'buttonPos' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('screentype-favoritestore').removeAll();
		}
		
		if (Ext.data.StoreManager.lookup('screentype-favoritestore-screens') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-favoritestore-screens',
				fields : [ '_id', 'name', 'next', 'icon', 'passive','payload','type','zone' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('screentype-favoritestore-screens').removeAll();
		}

		if (Ext.data.StoreManager.lookup('screentype-favoritestore-buttons') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-favoritestore-buttons',
				fields : ['_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('screentype-favoritestore-buttons').removeAll();
		}

		
	},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
		var fIsPassive = false;
		var fHasNext = false;
		if (record.get('next') == true) {
			fHasNext = true;
		}
        var fHasIcon=false;
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
		var sReturn = '<table style="height:16px;"><tr>';
		var iColspaceCounter = 3;

		if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
		
		if (fIsPassive) {
			sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		} else {
			sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		}
		if (fHasNext) {
			sReturn += '<td>&gt;</td>';
		}
		return sReturn + '</tr></table>';
	},	

	gridStore : null,
	oButtonEdit:null,
	lblSelectorAnzeige:null,
	oButtonUp:null,
	oButtonDown:null,
	oButtonDelete:null,
	mainGrid:null,
	lvl1Grid:null,
	lvl2Grid:null,
	updateLvl2Grid:function (record) {
		if ((this.lvl1Grid.getSelectionModel().getSelection().length==0)&& (record==null)) {
			this.lvl2Grid.setVisible(false);
			return;
		}
		if (record==null)	
			record=this.lvl1Grid.getSelectionModel().getSelection()[0];
		var sceneNames=record.get('payload');
		var type=record.get('type');
		var zone=record.get('zone');
		Ext.data.StoreManager.lookup('screentype-favoritestore-buttons').removeAll();
		var icon1=dss.staticDataModel.getImagePathForScene(zone,type,5);
		var icon2=dss.staticDataModel.getImagePathForScene(zone,type,17);
		var icon3=dss.staticDataModel.getImagePathForScene(zone,type,18);
		var icon4=dss.staticDataModel.getImagePathForScene(zone,type,19)
		if (type==8) {
			icon1="images/dss/grpApp.png";
			icon2="images/dss/grpApp.png";
			icon3="images/dss/grpApp.png";
			icon4="images/dss/grpApp.png";
		}
			
		Ext.data.StoreManager.lookup('screentype-favoritestore-buttons').add([{
				_id:1,
				name:sceneNames.scene1,
				next:false,
				passive:false,
				icon: icon1
			},{
				_id:5,
				name:sceneNames.scene2,
				next:false,
				passive:false,
				icon: icon2
			},{
				_id:7,
				name:sceneNames.scene3,
				next:false,
				passive:false,
				icon: icon3
			},{
				_id:9,
				name:sceneNames.scene4,
				next:false,
				passive:false,
				icon: icon4
			}]);
		if (type!=8) {
			Ext.data.StoreManager.lookup('screentype-favoritestore-buttons').add([{
				_id:4,
				name:dss.staticDataModel.getNameForScene(zone,type,0),
				next:false,
				passive:true,
				icon: dss.staticDataModel.getImagePathForScene(zone,type,0)
			}]);
		}
		if (type==2) {
			Ext.data.StoreManager.lookup('screentype-favoritestore-buttons').add([{
				_id:3,
				name:dss.staticDataModel.getNameForScene(zone,2,56),
				next:false,
				passive:true,
				icon: dss.staticDataModel.getImagePathForScene(zone,2,56)
			},{
				_id:11,
				name:dss.staticDataModel.getNameForScene(zone,2,15),
				next:false,
				passive:true,
				icon: dss.staticDataModel.getImagePathForScene(zone,2,15)
			}]);
		}
		this.lvl2Grid.setVisible(true);
		
	},
	takeOverValue:function() {
		this.oButtonEdit.setText(_('edit favorite'));

		if (this.mainGrid.getSelectionModel().getSelection().length>0)
		if (this.lvl1Grid.getSelectionModel().getSelection().length>0)
		if (this.lvl2Grid.getSelectionModel().getSelection().length>0) {
			var baseRecord=this.mainGrid.getSelectionModel().getSelection()[0];
			var screenNumber=this.lvl1Grid.getSelectionModel().getSelection()[0].get('_id');
			var buttonNumber=this.lvl2Grid.getSelectionModel().getSelection()[0].get('_id');
			var text=this.lvl2Grid.getSelectionModel().getSelection()[0].get('name');
			baseRecord.beginEdit();
			baseRecord.set('screen',screenNumber);
			baseRecord.set('button',buttonNumber);
			baseRecord.set('name',text);
			baseRecord.endEdit();
			var baseDSID=this.dssEditor.editControls.basedSID.getValue();
			var baseStore=Ext.data.StoreManager.lookup(this.baseStore);
			for (var iIndex=0;iIndex<baseStore.getCount();iIndex++) {
				var oRecord=baseStore.getAt(iIndex);
				if (oRecord.get('basedSID')==baseDSID) {
					if (oRecord.get('internalScreenNumber')==screenNumber)
						baseRecord.set('type',oRecord.get('type'));
				}
			}
		}
		
	},
	startEdit:function(iIndex) {
		this.oButtonEdit.setText(_('show all favorites'));
    	this.editPanel.expand();    	
    	this.setEditPanel(iIndex);
	},
	setEditPanel : function (iIndex) {
		this.editPanel.setTitle(_('Favorite ' + (iIndex+1)));
		var selections=this.mainGrid.getSelectionModel().getSelection();

		this.lvl1Grid.getSelectionModel().deselectAll();
		this.lvl2Grid.getSelectionModel().deselectAll();
		this.lvl2Grid.setVisible(false);
		if (selections.length > 0) {
        	var oRecord=selections[0];
            var screenNumber=oRecord.get('screen');
            if (screenNumber!=15) {
                var buttonNumber=oRecord.get('button');
            	var lvl1Record=this.lvl1Grid.store.findRecord('_id',screenNumber,0,false,true,true);
            	if (lvl1Record!=null) {
            		this.lvl1Grid.getSelectionModel().select(lvl1Record);
            		this.updateLvl2Grid();
            		var lvl2Record=this.lvl2Grid.store.findRecord('_id',buttonNumber,0,false,true,true);
            		if (lvl2Record!=null)
            			this.lvl2Grid.getSelectionModel().select(lvl2Record);
            	}
            } 
        }
	},
	setSelectedMainRecord:function(index) {		
	},
	getSelectedMainRecord:function(index) {
		
	},
	eventHandlerSelectionChange: function () {
		var selections=this.mainGrid.getSelectionModel().getSelection();
		
        if (selections.length > 0) {
        	var oRecord=selections[0];
            this.oButtonEdit.setDisabled(false);
            this.oButtonDelete.setDisabled(oRecord.data.screen==15);
            var selIndex = -1;
            for ( var iIndex = 0; iIndex < this.mainGrid.store.getCount(); iIndex++) {
                if (this.mainGrid.store.getAt(iIndex) == selections[0])
                    selIndex = iIndex;
            }
            this.oButtonUp.setDisabled(selIndex == 0);
            this.oButtonDown.setDisabled(selIndex == (this.mainGrid.store.getCount() - 1));
            var iIndex = this.mainGrid.store.indexOf(selections[0]);
            this.lblSelectorAnzeige.setText(Ext.String.format2(_('Favorite {index}/{count}'),{index:''+(iIndex + 1),count:''+this.mainGrid.store.getCount()}),false);
        } else {
            this.oButtonEdit.setDisabled(true);
            this.oButtonDelete.setDisabled(true);
            this.oButtonUp.setDisabled(true);
            this.oButtonDown.setDisabled(true);
        }
	},
	constructor : function(config) {
		var me=this;
		this.initStores();
		this.baseStore = 'thanosStore';
		if (config.baseStore!=null)
			this.baseStore=config.baseStore;
        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right'
            }
        });

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('edit favorite'),
            disabled : true,
            handler : function() {
            	var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
            	if (me.editPanel.getCollapsed()) {
            		me.startEdit(iIndex);
            	} else {
            		me.takeOverValue();
                	me.editPanel.collapse();
            	}
            }
        });
        
        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
                me.mainGrid.getSelectionModel().setCurrentPosition({row: iIndex-1, column: 0});
        		if (!me.editPanel.getCollapsed())
        			me.setEditPanel(iIndex-1);
            }
        });
        

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = me.mainGrid.store.indexOf(me.mainGrid.getSelectionModel().getSelection()[0]);
                me.mainGrid.getSelectionModel().setCurrentPosition({row: iIndex+1, column: 0});
        		if (!me.editPanel.getCollapsed())
        			me.setEditPanel(iIndex+1);
            }
        });
        
        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('reset favorite'),
            disabled : true,
            handler : function() {
            	var oRecord=me.mainGrid.getSelectionModel().getSelection()[0];
            	oRecord.set('screen',15);
            	oRecord.set('button',15);
            	oRecord.set('type',0);
            	oRecord.set('name',oRecord.get('defaultname'));
            	me.oButtonDelete.setDisabled(true);
            }
        });
        
        var selModel=Ext.create('Ext.selection.CellModel',
                {allowDeselect:true,
                 mode:'SINGLE'});

        var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit : 1 });

    	this.lvl1Grid = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : 184,
			width : 300,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store :Ext.data.StoreManager.lookup('screentype-favoritestore-screens'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});    	
        this.lvl2Grid = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : 184,
			width : 300,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('screentype-favoritestore-buttons'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
        this.lvl2Grid.setVisible(false);
        this.lvl1Grid.on('itemclick', function(grid, record) {
			var fIsPassive = false;
			
			me.updateLvl2Grid(record);
			
			
			this.getSelectionModel().deselectAll();
			this.getSelectionModel().select(record);
			
		});
        this.lvl2Grid.on('itemdblclick', function(grid, record) {
        	me.takeOverValue();
        	me.editPanel.collapse();
        });
        
        this.mainGrid = Ext.create('Ext.grid.Panel', {
            enableColumnHide : false,
            enableColumnMove : false,
            selType : 'cellmodel',
            border : '0',
            region : 'center',
            height : "100%",
            store :Ext.data.StoreManager.lookup('screentype-favoritestore'),
            hideHeaders : true,
            overflowX:'hidden',                
            plugins : [ cellEditing ],
            width:772,
            viewConfig : {
                stripeRows : true
            },
            columns : [ {
                header : _(''),
                dataIndex : 'defaultname',
                sortable : false,
                hideable : false,
                flex:1,
                renderer: function(val, metadata, record, colIdx, store, view) {
                	var delta=200;
                	if (me.getWidth()<700)
                		delta=100;
                	var sString= '<table><tr><td><img src="images/position/Buttons' + record.get('buttonPos')+ '.png"></td>'
                	sString+='<td style="padding-right:5px;width:'+delta+'px;">';
                	sString+= _( record.get('defaultname'));
                	sString+='</td>';
                	var scene;
            		
                	if (record.get('screen')==15)
                		sString+='<td>' + _('not used') + '</td>';
                	else {
                		
                		var zone;
                		var group;
                		if (me.dssEditor==null)
                			return "";
                		var baseDSID=me.dssEditor.editControls.basedSID.getValue();
                		var baseStore=Ext.data.StoreManager.lookup(me.baseStore);
                		for (var iIndex=0;iIndex<baseStore.getCount();iIndex++) {
                			var oRecord=baseStore.getAt(iIndex);
                			if (oRecord.get('basedSID')==baseDSID) {                				
            					if (record.get('screen')==oRecord.get('internalScreenNumber')) {
                					zone=oRecord.get('zoneID');                					
                   					group=parseInt('' + oRecord.get('type'));
                   				    scene=getSceneForButton(group,oRecord.get('buttontype'),record.get('button'));                					
            					}
                			}
                		}
                		                		                		
		                if (group==8){
		                	var f=function (buttonNr) {
		                		switch(buttonNr) {
		                		case 1:
		                			return 1;
		                		case 5:
		                			return 2;
		                		case 7:
		                			return 3;
		                		case 9:
		                			return 4;		                			
		                		}		            
		                	};
		                	sString +='<td colspan="2">';
		                	sString +=Ext.String.format2(_('Generic pushbutton #{buttonnumber} (screen {screennumber})'),{buttonnumber:record.get('button'),screennumber:record.get('screen')});
		                	sString +='</td>';
		                }		                	
		                else {		                	
	                		sString += '<td style="padding-right:5px;">'
	                			+ dss.staticDataModel.getImageForScene(zone, group, scene) + "</td>";

			                sString += '<td style="">';
			                sString += dss.staticDataModel.getNameForScene(zone, group, scene);
			                sString += _(' for ') + dss.staticDataModel.getNameForGroup(zone, group);
			                sString += _(" in ") + dss.staticDataModel.getNameForZone(zone);
		                }
		                sString += "</td>";
                	}
                	sString+='</tr></table>';
                	return sString;
                }
            } ,{
                header : 'custom name',
                dataIndex : 'name',
                sortable : false,
                hideable : false,
                width:200,                
                editor : {
                    xtype : 'textfield',
                    allowBlank : false,
                    blankText : _('This field is required'),
                    invalidText : _('The value in this field is invalid'),
                    listeners : {
                    	beforeedit : {
                    		fn : function(editor,gridObject) {
                        		if (gridObject.record.get('screen')==15)
                        			return false;
                        		return true;
                        	}
                    	}
                    },
                    maxLength:12,
        			enforceMaxLength:true
                },
                renderer: function(val, metadata, record, colIdx, store, view) {
                	if (record.get('screen')==15)
                		return '';
                	return val;
                }
            } ],
            tbar : [ this.oButtonEdit,
            '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
        });
        this.mainGrid.getSelectionModel().addListener('select',function(grid,record,row,column) {
           me.eventHandlerSelectionChange(me.mainGrid,[record]);
        });
		
        this.mainGrid.on({
        	itemdblclick : function(grid, record,item,index,e) {     
        		me.startEdit(index);               
	        }, 
        	beforeedit : function(editor,gridObject) {
        		if (gridObject.record.get('screen')==15)
        			return false;
        		return true;
        	}    	
        });

        
		this.editPanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			region : 'south',
            title : ' ',
            collapsible : true,
            collapsed : true,
            autoScroll : true,
            animCollapse : true,
            height : 212,
            width: 700,
            hideCollapseTool:true,            
			layout : {
				type : 'hbox'
			},
			items : [this.lvl1Grid,this.lvl2Grid],
			scroll : 'horizontal',
			listeners : {
				beforecollapse : function(pPanel) {
            		pPanel.setTitle(' ');
            	}
			}
		});

		var me = this;	

		Ext.apply(this, {
			items : [ this.mainGrid,this.editPanel ],
			height: 240,
			layout: {
				type: 'border'
			}
		});
	
		Ext.data.StoreManager.on('clear',function () {
			me.initStores();
			me.mainGrid.reconfigure(Ext.data.StoreManager.lookup('screentype-favoritestore'));
	        me.lvl2Grid.reconfigure(Ext.data.StoreManager.lookup('screentype-favoritestore-buttons'));
	    	me.lvl1Grid.reconfigure(Ext.data.StoreManager.lookup('screentype-favoritestore-screens'));	
		});
		
		this.callParent(arguments);
	},
	reset : function() {
		Ext.data.StoreManager.lookup('screentype-favoritestore').removeAll();
	
		Ext.data.StoreManager.lookup('screentype-favoritestore').add([{
			'_id':0,
			'defaultname':_('Favorite 1'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 1'),
			'buttonPos' :1 
		},{
			'_id':1,
			'defaultname':_('Favorite 2'),
			'screen' : 15,
			'button' : 15,
			'type' : 15,
			'name' : _('Favorite 2'),
			'buttonPos' : 4
		},{
			'_id':2,
			'defaultname':_('Favorite 3'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 3'),
			'buttonPos' : 5
		},{
			'_id':3,
			'defaultname':_('Favorite 4'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 4'),
			'buttonPos' : 6
		},{
			'_id':4,
			'defaultname':_('Favorite 5'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 5'),
			'buttonPos' : 7
		},{
			'_id':5,
			'defaultname':_('Favorite 6'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 6'),
			'buttonPos' : 8
		},{
			'_id':6,
			'defaultname':_('Favorite 7'),
			'screen' : 15,
			'button' : 15,
			'type' : 0,
			'name' : _('Favorite 7'),
			'buttonPos' : 9
		}]);

        this.lvl2Grid.setVisible(false);
        this.editPanel.collapse();

	},
	isValid : function() {
		return true;
	},
	setValue : function(oValue) {
		this.reset();
        this.lvl2Grid.setVisible(false);
        this.editPanel.collapse();
        if (oValue==null)
        	this.reset();
        else {
	        Ext.data.StoreManager.lookup('screentype-favoritestore').removeAll();
			
			for (var iIndex=0;iIndex<7;iIndex++) {
				var oObject={
					'_id':iIndex,
					'defaultname':_('Favorite ' + (iIndex+1)) 
				};
				oObject.screen=oValue['' + iIndex].screen;
				oObject.button=oValue['' + iIndex].button;
				oObject.type=oValue['' + iIndex].type;
				oObject.name=oValue['' + iIndex].name;
				switch (iIndex) {
					case 0:
						oObject.buttonPos=1;
					break;
					case 1:
						oObject.buttonPos=4;
					break;
					case 2:
						oObject.buttonPos=5;
					break;
					case 3:
						oObject.buttonPos=6;
					break;
					case 4:
						oObject.buttonPos=7;
					break;
					case 5:
						oObject.buttonPos=8;
					break;
					case 6:
						oObject.buttonPos=9;
					break;
				}
				Ext.data.StoreManager.lookup('screentype-favoritestore').add(oObject);
			}
        }
		Ext.data.StoreManager.lookup('screentype-favoritestore-screens').removeAll();
		var baseDSID=this.dssEditor.editControls.basedSID.getValue();
		var baseStore=Ext.data.StoreManager.lookup(this.baseStore);
		for (var iIndex=0;iIndex<baseStore.getCount();iIndex++) {
			var oRecord=baseStore.getAt(iIndex);
			if (oRecord.get('basedSID')==baseDSID) {
				var type=oRecord.get('type');
				if (type!=-1) 
					if (type!=48) {
					var zone=oRecord.get('zoneID');
					var sceneNames=oRecord.get('sceneNames');
					var internalScreenNumber=oRecord.get('internalScreenNumber');
					var sName=Ext.String.format2(_('{screenType} (Screen {screenNumber}) for {zoneName}'), { 
							      screenType:dss.staticDataModel.getNameForGroup(0,parseInt('' + type,10)),
								  screenNumber:(internalScreenNumber),
								  zoneName:dss.staticDataModel.getNameForZone(parseInt('' + zone,10))
								});
					var oObject={
						_id:(internalScreenNumber),
						name:sName,
						next:true,
						passive:false,
						icon: dss.staticDataModel.getImagePathForGroup(0,parseInt('' + type,10)),
						payload:sceneNames,
						type:type,
						zone:zone
					};
					Ext.data.StoreManager.lookup('screentype-favoritestore-screens').add(oObject);
				}
			}
		}
		
	},
	getValue : function() {
		if (!this.editPanel.getCollapsed())
			this.takeOverValue();
		var oObject={};
		for (var iIndex=0;iIndex<Ext.data.StoreManager.lookup('screentype-favoritestore').getCount();iIndex++) {
			var oRecord=Ext.data.StoreManager.lookup('screentype-favoritestore').getAt(iIndex);
			var subObject={}
			subObject.name=oRecord.get('name');
			subObject.targetScreen=oRecord.get('screen');
			subObject.targetButton=oRecord.get('button');
			oObject['favorite' + (oRecord.get('_id')+1)]=subObject;
		}
		return oObject;
	}
});